my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post

#C'est la partie de la chasse qui ne prend en compte que ceux qui ont le droit de chasser

###############################################################################
#                              COIN ! COIN !                                  #
###############################################################################

##ici, on s'occupe des coincoins

##un coincoin, c'est ça
coincoin = Regexp.new("((\\\\_([o0O@]|(&ocirc;)|(&deg;)|(&oslash;)|(&ograve;)|(&oacute;)|ô|°|ø|ò|ó)(&lt;|<))|((&gt|>);([o0O@]|(&ocirc;)|(&deg;)|(&oslash;)|(&ograve;)|(&oacute;)|ô|°|ø|ò|ó)_/)|(coin ?! ?coin ?!))")

##on enregistre chaque coincoin avec son heure d'envol et son expediteur
##si la chasse n'est pas ouverte 24/24, changer avec cette ligne:
#if ( coincoin =~ my_post.message and ( my_post.timestamp[8..9].to_i < 1 or my_post.timestamp[8..9].to_i > 10 ))
if coincoin =~ my_post.message
  ##on ajoute le coincoin à la table
  dbh("do","INSERT INTO #{my_tribune.db_prefix}coincoins (post_id, login, post_time, doublon) VALUES (?,?,?,?)",my_post.post_id, my_post.login, my_post.timestamp, my_post.doublon)

  ##et on ajoute ce coincoin aux logs
  dbh("do","INSERT INTO #{my_tribune.db_prefix}chasse_log (post_time, login, quoi, message) VALUES (?,?,?,?)",my_post.timestamp, my_post.login, "nouveau", my_post.message)


  ##ensuite, on ajoute un point au nombre de "lancés" de l'expéditeur
  dbh("do","INSERT INTO #{my_tribune.db_prefix}chasseurs (login, lance) VALUES (?,1) ON DUPLICATE KEY UPDATE lance=lance+1", my_post.login)

end ##fin de la détection des canards


###############################################################################
#                              PAN ! PAN !                                    #
###############################################################################

##un panpan, c'est ça
panpan = Regexp.new(/^(([0-1][0-9])|(2[0-3])):([0-5][0-9])(:[0-5][0-9])?(&sup1;|&sup2;|&sup3;|¹|²|³|\\\^[1-9]|:[1-9])? *:? *pan *! pan *! *$/)

##si le message est un panpan, on cherche quelle est sa cible
##si la chasse n'est pas ouverte 24/24, changer avec cette ligne:
#if ( coincoin =~ .message and ( my_post.timestamp[8..9].to_i < 1 or my_post.timestamp[8..9].to_i > 10 ))
if panpan =~ my_post.message
  pan = my_post.message.scan(panpan)[0]
  pan_h = pan[0]
  pan_m = pan[3]
  pan_s = pan[4]
  if pan_s != nil ; pan_s = pan_s.delete(":"); end
  pan_d = pan[5]

  if ( pan_h == "23" and my_post.nhorloge[0..1] == "00" )
    pan_date = my_post.timestamp_Time.-(24*3600).strftime("%Y%m%d")
  else
    pan_date = my_post.date.to_s
  end

  if pan_s == nil ##c'est une nhorloge en hh:mm
    coin = dbh("select_one","SELECT id,login,post_time, TIME_TO_SEC( TIMEDIFF(?, post_time) ) AS age FROM #{my_tribune.db_prefix}coincoins WHERE seul = 1 AND post_time regexp ?", my_post.timestamp, pan_date + pan_h + pan_m + ".." )
    cible_nhorloge = pan_h + ":" + pan_m
    cible = pan_date[0..3] + "-" + pan_date[4..5] + "-" + pan_date[6..7] + " " + cible_nhorloge + ":00"

  elsif pan_d != nil ##c'est une nhorloge en hh:mm:ss:d
    pan_d = pan_d.sub("&sup","").sub(";","").sub("^","").sub(":","").sub("¹","1").sub("²","2").sub("³","3")
    coin = dbh("select_one","SELECT id,login,post_time, TIME_TO_SEC( TIMEDIFF(?, post_time) ) AS age FROM #{my_tribune.db_prefix}coincoins WHERE doublon = ? AND post_time = ?", my_post.timestamp, pan_d, pan_date + pan_h + pan_m + pan_s)
    cible_nhorloge = pan_h + ":" + pan_m + ":" + pan_s + ":" +pan_d
    cible = pan_date[0..3] + "-" + pan_date[4..5] + "-" + pan_date[6..7] + " " + pan_h + ":" + pan_m + ":" + pan_s
  
  else ##c'est une nhorloge en hh:mm:ss
    coin = dbh("select_one","SELECT id,login,post_time, TIME_TO_SEC( TIMEDIFF(?, post_time) ) AS age FROM #{my_tribune.db_prefix}coincoins WHERE doublon = 0 AND post_time = ?", my_post.timestamp, pan_date + pan_h + pan_m + pan_s)
    cible_nhorloge = pan_h + ":" + pan_m + ":" + pan_s
    cible = pan_date[0..3] + "-" + pan_date[4..5] + "-" + pan_date[6..7] + " " + cible_nhorloge
  end


  #on crée le chasseur, le cas échéant
  dbh("do","INSERT IGNORE INTO #{my_tribune.db_prefix}chasseurs (login) VALUES (?)  ", my_post.login)

  chasseur = dbh("select_one","SELECT points FROM #{my_tribune.db_prefix}chasseurs WHERE login = ?", my_post.login)




  if coin == nil
    quoi = "ratai"
    patience = nil
  else
    cible = coin[:post_time]
    patience = coin[:age]

    ##est-ce le canard du tireur?
    if ( my_post.login == coin[:login] )
      quoi = "self"

    ##a-t-on été trop patient?
    elsif ( patience > 300 )
      quoi = "ratai"

    ##ce n'est pas son canard, et il a moins de 300s, il est donc valide.
    else
      #points = -50 / ( patience + 5 ) + 200 * ( patience / 300) ** 2
      points = (-50 / ( patience.to_f + 5 ) + 200 * ( patience.to_f / 300) ** 2 ).round.to_i

      ##si le chasseur est déjà en-dessous de -100, et que 'points' est négatif, le canard survit (on retirera les 10 points plus tard)
      if ( chasseur[:points] < -100 and points < 0 )
        quoi = "mauvais"

      ##sinon, le tir est valide, on l'ajoute
      else
        quoi = "tue"

        dbh("do","UPDATE #{my_tribune.db_prefix}chasseurs SET score = score + 1 , points = points + ? , patience = patience + ? WHERE login = ? ", points, patience, my_post.login)

        ##et on tue le canard
        dbh("do","DELETE FROM #{my_tribune.db_prefix}coincoins WHERE id = ?", coin[:id])
      end

    end

  end


  ##si c'était un coup pour rien, on retire 10 points (niark niark)
  ##NB: coup pour rien= tout sauf un coup valide (y compris coup trop rapide d'un joueur déjà < -100,
  ##tir sur son canard, tir après 5 minutes, tir sur un cadavre ou sur un leurre)
  if quoi == "ratai" || quoi == "self" || quoi == "mauvais"
    points=-10

    dbh("do","UPDATE #{my_tribune.db_prefix}chasseurs SET ratai = ratai + 1 , points = points - 10 WHERE login = ?", my_post.login)
  end

  ##et on ajoute tout ça aux logs
  dbh("do","INSERT INTO #{my_tribune.db_prefix}chasse_log (post_time, login, quoi, cible, points, patience) VALUES (?,?,?,?,?,?)",my_post.timestamp, my_post.login, quoi, cible, points, patience)


end ##fin de la gestion des panpan