my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post

###############################################################################
#                                     CONVERT                                 #
###############################################################################
liste_monnaies={"AED"=>"United Arab Emirates Dirham (AED)","ANG"=>"Netherlands Antillean Gulden (ANG)","ARS"=>"Argentine Peso (ARS)","AUD"=>"Australian Dollar (AUD)","BGN"=>"Bulgarian Lev (BGN)","BHD"=>"Bahraini Dinar (BHD)","BND"=>"Brunei Dollar (BND)","BOB"=>"Bolivian Boliviano (BOB)","BRL"=>"Brazilian Real (BRL)","BWP"=>"Botswana Pula (BWP)","CAD"=>"Canadian Dollar (CAD)","CHF"=>"Swiss Franc (CHF)","CLP"=>"Chilean Peso (CLP)","CNY"=>"Chinese Yuan (renminbi) (CNY)","COP"=>"Colombian Peso (COP)","CSD"=>"Serbian Dinar (CSD)","CZK"=>"Czech Koruna (CZK)","DKK"=>"Danish Krone (DKK)","EEK"=>"Estonian Kroon (EEK)","EGP"=>"Egyptian Pound (EGP)","EUR"=>"Euro (EUR)","FJD"=>"Fijian Dollar (FJD)","GBP"=>"British Pound (GBP)","HKD"=>"Hong Kong Dollar (HKD)","HNL"=>"Honduran Lempira (HNL)","HRK"=>"Croatian Kuna (HRK)","HUF"=>"Hungarian Forint (HUF)","IDR"=>"Indonesian Rupiah (IDR)","ILS"=>"New Israeli Sheqel (ILS)","INR"=>"Indian Rupee (INR)","ISK"=>"Icelandic Króna (ISK)","JPY"=>"Japanese Yen (JPY)","KRW"=>"South Korean Won (KRW)","KWD"=>"Kuwaiti Dinar (KWD)","KZT"=>"Kazakhstani Tenge (KZT)","LKR"=>"Sri Lankan Rupee (LKR)","LTL"=>"Lithuanian Litas (LTL)","MAD"=>"Moroccan Dirham (MAD)","MUR"=>"Mauritian Rupee (MUR)","MXN"=>"Mexican Peso (MXN)","MYR"=>"Malaysian Ringgit (MYR)","NOK"=>"Norwegian Krone (NOK)","NPR"=>"Nepalese Rupee (NPR)","NZD"=>"New Zealand Dollar (NZD)","OMR"=>"Omani Rial (OMR)","PEN"=>"Peruvian Nuevo Sol (PEN)","PHP"=>"Philippine Peso (PHP)","PKR"=>"Pakistani Rupee (PKR)","PLN"=>"Polish Złoty (PLN)","QAR"=>"Qatari Riyal (QAR)","RON"=>"New Romanian Leu (RON)","RUB"=>"Russian Ruble (RUB)","SAR"=>"Saudi Riyal (SAR)","SEK"=>"Swedish Krona (SEK)","SGD"=>"Singapore Dollar (SGD)","SIT"=>"Slovenian Tolar (SIT)","SKK"=>"Slovak Koruna (SKK)","THB"=>"Thai Baht (THB)","TRY"=>"New Turkish Lira (TRY)","TTD"=>"Trinidad and Tobago Dollar (TTD)","TWD"=>"New Taiwan Dollar (TWD)","UAH"=>"Ukrainian Hryvnia (UAH)","USD"=>"United States Dollar (USD)","VEB"=>"Venezuelan Bolívar (VEB)","ZAR"=>"South African Rand (ZAR)"}

#syntaxe : #convert 123.45 CUR CUR

conversion = my_post.message.match(/^#convert +([0-9\.,]* +)?([A-Z]{3}) +([A-Z]{3})/)

if conversion != nil
  log("(" + my_post.timestamp + ") Demande de conversion par " + my_post.login_str + " : " + my_post.message)
  if conversion[1] != nil
    montant = conversion[1].sub(",",".").to_f
  else
    montant = 1
  end

  from = conversion[2].upcase
  to = conversion[3].upcase

  if (liste_monnaies[to] == nil || liste_monnaies[from] == nil)
    envoi(my_tribune, my_post.nhorloge2 + " devise(s) inconnue(s). La liste des devises acceptées est ici : " + my_tribune.webroot + "devises.rhtml")
  else
    h = Net::HTTP.start("finance.google.com")
    data = h.get("/finance/converter?a=#{montant}&from=#{from}&to=#{to}")
    h.finish
    
    resultat = data.body.match(/^([0-9\.]*)&nbsp;#{from}&nbsp;=&nbsp;<span class=bld>([0-9\.]*)&nbsp;#{to}<\/span>/)
    envoi(my_tribune, my_post.nhorloge2 + " " + resultat[1] + " " + from + " = " + resultat[2] + " " + to)
  end
end
