my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post

###############################################################################
#                               PREUM'S PAR ÉQUIPE                            #
###############################################################################

equipes_regexp = Regexp.new('^#(é|e)quipe +(.+)$')

##si le message contient "#equipe nom_equipe", le joueur est ajouté à l'équipe nom_equipe
equipe =  my_post.message.scan(equipes_regexp)

if equipe != []
  equipe = equipe[0][1]
  ##on créé le preumseur, s'il n'existe pas déjà
  dbh("do","INSERT IGNORE INTO #{my_tribune.db_prefix}preums (login) VALUES(?)", my_post.login)

  ##si l'équipe est "0", ça veut dire pas d'équipe
  if equipe == "0"
    dbh("do","UPDATE #{my_tribune.db_prefix}preums SET equipe = 0  WHERE login = ?", my_post.login)

    log("(" + my_post.timestamp + ") " + my_post.login_str + " preumse en solo")

  else
    ##on créé l'équipe, si elle n'existe pas déjà
    dbh("do","INSERT IGNORE INTO #{my_tribune.db_prefix}preums_equipes (nom) VALUES(?)", equipe)

    ##et on attribue l'équipe
    dbh("do","UPDATE (#{my_tribune.db_prefix}preums,#{my_tribune.db_prefix}preums_equipes) SET #{my_tribune.db_prefix}preums.equipe=#{my_tribune.db_prefix}preums_equipes.id WHERE #{my_tribune.db_prefix}preums_equipes.nom = ? and #{my_tribune.db_prefix}preums.login = ?", equipe, my_post.login)

    log("(" + my_post.timestamp + ") " + my_post.login_str + " a rejoint l'équipe " + equipe) 

  end

end

##fin de la gestion des équipes
