my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post

###############################################################################
#                               RÉPONDEUR                                     #
###############################################################################

##ici, on s'occupe du répondeur
moule_regexp = Regexp.new('\w+&lt;')

##si le message contient "login<", on le traite (avec éventuellement l'appel de plusieurs moules, voire de toutes)
my_post.message.scan(moule_regexp).each { |e|
  ##on regarde d'abord si la moule a configuré son répondeur, et s'il est activé, puis on ajoute le message
  enmarche = dbh("select_one","SELECT etat FROM #{my_tribune.db_prefix}repondeur_conf WHERE login = ?", e.gsub("&lt;","") ).to_s

  if enmarche == "1"
    dbh("do","INSERT INTO #{my_tribune.db_prefix}repondeur (dest,post_time,login,info,message) VALUES (?,?,?,?,?)", e.gsub("&lt;",""), my_post.timestamp, my_post.login, my_post.ua, my_post.message)
  end
        
  ##si le message est pour toutes les moules<, on l'ajoute à tous les répondeurs actifs et publics
  if e.gsub("&lt;","") == "moules"
    moules = dbh("select_all","SELECT login FROM #{my_tribune.db_prefix}repondeur_conf WHERE etat = true AND prive = false")

    moules.each{ |dest|
      dbh("do","INSERT INTO #{my_tribune.db_prefix}repondeur (dest,post_time,login,info,message) VALUES (?,?,?,?,?)", dest.to_s, my_post.timestamp, my_post.login, my_post.ua, my_post.message)
    }
  end
}
##fin du répondeur
